#!/bin/sh

echo
echo "Writing test_uuid_hash output to 'test_temp.txt'."
./test_uuid_hash >test_temp.txt
./gen_test_data -s
echo

echo -n "SHA256 test 1, NIST short messages       - "
if ./test_sha256 test_data/SHA256ShortMsg.txt | grep FAIL ; then
	echo "FAIL"
else
	echo "success"
fi

echo -n "SHA256 test 1, NIST long messages        - "
if ./test_sha256 test_data/SHA256LongMsg.txt | grep FAIL ; then
	echo "FAIL"
else
	echo "success"
fi

echo -n "test_uuid_hash against reference data    - "
if diff test_data/test_uuid_reference.txt test_temp.txt ; then
	echo "success"
else
	echo "FAIL"
fi

echo -n "gen_test_data -s against reference data  - "
if diff test_data/simulated_patient_records_small.txt simulated_patient_records_small.txt ; then
	echo "success"
else
	echo "FAIL"
fi

echo -n "test_vector_data using reference data    - "
if ./test_vector_data -q test_data/simulated_patient_records_small.txt ; then
	echo "success"
fi

echo -n "Single record test 1                     - "
if ./compute_single_uuid -q test_data/single_record_1.txt | grep -v o5i9vah7129u ; then
	echo "FAIL"
else
	echo "success"
fi

echo -n "Single record test 2                     - "
if ./compute_single_uuid -q test_data/single_record_2.txt | grep -v dlvhmf5snenp ; then
	echo "FAIL"
else
	echo "success"
fi

echo -n "Single record test 3                     - "
if ./compute_single_uuid -q test_data/single_record_3.txt | grep -v 000000000000 ; then
	echo "FAIL"
else
	echo "success"
fi

echo -n "Single record test, bad input data       - "
if ./compute_single_uuid -q test_data/single_record_bad.txt | grep UUID: ; then
	echo "FAIL"
else
	echo "success"
fi

echo -n "CSV format record file #1                - "
if ./compute_csv_uuids test_data/test_records.csv test_out.csv ; then
	echo "FAIL"
else
	if diff test_data/test_records_output.csv test_out.csv ; then
		echo "success"
	else
		echo "FAIL"
	fi
fi

echo -n "CSV format record file #2                - "
if ./compute_csv_uuids test_data/test_records_2.csv test_out.csv > /dev/null ; then
	echo "FAIL"
else
	if diff test_data/test_records_output_2.csv test_out.csv ; then
		echo "success"
	else
		echo "FAIL"
	fi
fi

echo
