
/* ************************************************************************* */
/*
 *	util_tests.h
 *
 *	(C) 2010 VOCAL Technologies, Ltd.
 *
 *	This software is intended for use as a reference/standard implementation,
 *	and has been placed into the public domain by the copyright holder:
 *
 *	VOCAL Technologies, Ltd.
 *	90A John Muir Drive.
 *	Buffalo, NY  14228
 *
 *	Maintainer:  Dennis Towne
 */
/* ************************************************************************* */

#include <stdio.h>

/***************************************************************************/
/* general structure definition for holding test data */
/***************************************************************************/

#define MAX_NAME_LEN          100
#define MAX_SSN_LEN            32
#define MAX_UUID_LEN          100

struct test_data {
	int record_number;

	char policy_name[MAX_NAME_LEN];
	char policy_ssn [MAX_SSN_LEN];
	int policy_gender;
	int policy_year;
	int policy_month;
	int policy_day;

	char patient_name[MAX_NAME_LEN];
	char patient_ssn [MAX_SSN_LEN];
	int patient_gender;
	int patient_year;
	int patient_month;
	int patient_day;

	char uuid[MAX_UUID_LEN];
};

void init_test_data(struct test_data *td);
int generate_test_uuid(struct test_data *td, char *uuid_dest);

/***************************************************************************/
/* various file and string handling utilities */
/***************************************************************************/

int fget_line(FILE *stream, char *dest, int dest_size);

int wordcmp(const char *data, const char *ref);
char *next_arg(char *string);
void strxcpy(char *dest, const char *src, unsigned int dest_len);
